Index: pjproject/trunk/pjsip/src/pjsip/sip_transaction.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_transaction.c	(revision 108)
+++ pjproject/trunk/pjsip/src/pjsip/sip_transaction.c	(revision 109)
@@ -30,4 +30,6 @@
 #include <pj/guid.h>
 #include <pj/log.h>
+
+#define THIS_FILE   "sip_transaction.c"
 
 /*****************************************************************************
@@ -102,4 +104,5 @@
     TSX_HAS_PENDING_SEND	= 4,
     TSX_HAS_PENDING_DESTROY	= 8,
+    TSX_HAS_RESOLVED_SERVER	= 16,
 };
 
@@ -413,4 +416,5 @@
     PJ_ASSERT_RETURN(mod_tsx_layer.endpt==NULL, PJ_EINVALIDOP);
 
+    PJ_LOG(5,(THIS_FILE, "Initializing transaction layer module"));
 
     /* Initialize TLS ID for transaction lock. */
@@ -462,4 +466,6 @@
     }
 
+    PJ_LOG(4,(THIS_FILE, "Transaction layer module initialized"));
+
     return PJ_SUCCESS;
 }
@@ -581,4 +587,6 @@
     pj_hash_iterator_t it_buf, *it;
 
+    PJ_LOG(4,(THIS_FILE, "Stopping transaction layer module"));
+
     pj_mutex_lock(mod_tsx_layer.mutex);
 
@@ -587,7 +595,8 @@
     while (it) {
 	pjsip_transaction *tsx = pj_hash_this(mod_tsx_layer.htable, it);
+	pj_hash_iterator_t *next = pj_hash_next(mod_tsx_layer.htable, it);
 	if (tsx)
 	    tsx_destroy(tsx);
-	it = pj_hash_next(mod_tsx_layer.htable, it);
+	it = next;
     }
 
@@ -611,4 +620,6 @@
     mod_tsx_layer.endpt = NULL;
 
+    PJ_LOG(4,(THIS_FILE, "Transaction layer module destroyed"));
+
     return PJ_SUCCESS;
 }
@@ -628,5 +639,7 @@
     /* Find transaction. */
     pj_mutex_lock( mod_tsx_layer.mutex );
+
     tsx = pj_hash_get( mod_tsx_layer.htable, key.ptr, key.slen );
+
     if (tsx == NULL || tsx->state == PJSIP_TSX_STATE_TERMINATED) {
 	/* Transaction not found.
@@ -667,5 +680,7 @@
     /* Find transaction. */
     pj_mutex_lock( mod_tsx_layer.mutex );
+
     tsx = pj_hash_get( mod_tsx_layer.htable, key.ptr, key.slen );
+
     if (tsx == NULL || tsx->state == PJSIP_TSX_STATE_TERMINATED) {
 	/* Transaction not found.
@@ -791,5 +806,51 @@
 static void tsx_destroy( pjsip_transaction *tsx )
 {
+    struct tsx_lock_data *lck;
+
+    /* Decrement transport reference counter. */
+    if (tsx->transport) {
+	pjsip_transport_dec_ref( tsx->transport );
+	tsx->transport = NULL;
+    }
+    /* Free last transmitted message. */
+    if (tsx->last_tx) {
+	pjsip_tx_data_dec_ref( tsx->last_tx );
+	tsx->last_tx = NULL;
+    }
+    /* Cancel timeout timer. */
+    if (tsx->timeout_timer._timer_id != -1) {
+	pjsip_endpt_cancel_timer(tsx->endpt, &tsx->timeout_timer);
+	tsx->timeout_timer._timer_id = -1;
+    }
+    /* Cancel retransmission timer. */
+    if (tsx->retransmit_timer._timer_id != -1) {
+	pjsip_endpt_cancel_timer(tsx->endpt, &tsx->retransmit_timer);
+	tsx->retransmit_timer._timer_id = -1;
+    }
+
+    /* Clear some pending flags. */
+    tsx->transport_flag &= ~(TSX_HAS_PENDING_RESCHED | TSX_HAS_PENDING_SEND);
+
+    /* Refuse to destroy transaction if it has pending resolving. */
+    if (tsx->transport_flag & TSX_HAS_PENDING_TRANSPORT) {
+	tsx->transport_flag |= TSX_HAS_PENDING_DESTROY;
+	PJ_LOG(5,(tsx->obj_name, "Will destroy later because transport is "
+				 "in progress"));
+	return;
+    }
+
+    /* Clear TLS, so that mutex will not be unlocked */
+    lck = pj_thread_local_get(pjsip_tsx_lock_tls_id);
+    while (lck) {
+	if (lck->tsx == tsx) {
+	    lck->is_alive = 0;
+	}
+	lck = lck->prev;
+    }
+
     pj_mutex_destroy(tsx->mutex);
+
+    PJ_LOG(5,(tsx->obj_name, "Transaction destroyed!"));
+
     pjsip_endpt_release_pool(tsx->endpt, tsx->pool);
 }
@@ -807,5 +868,5 @@
     PJ_UNUSED_ARG(theap);
 
-    PJ_LOG(5,(tsx->obj_name, "got timer event (%s timer)", 
+    PJ_LOG(6,(tsx->obj_name, "%s timer event", 
 	     (entry->id==TSX_TIMER_RETRANSMISSION ? "Retransmit":"Timeout")));
 
@@ -832,5 +893,5 @@
                            void *event_src )
 {
-    PJ_LOG(4, (tsx->obj_name, "STATE %s-->%s, cause = %s",
+    PJ_LOG(5, (tsx->obj_name, "State changed from %s to %s, event=%s",
 	       state_str[tsx->state], state_str[state], 
                pjsip_event_str(event_src_type)));
@@ -860,29 +921,14 @@
 	pj_time_val timeout = {0, 0};
 
-	/* Decrement transport reference counter. */
-	if (tsx->transport) {
-	    pjsip_transport_dec_ref( tsx->transport );
-	    tsx->transport = NULL;
-	}
-	/* Free last transmitted message. */
-	if (tsx->last_tx) {
-	    pjsip_tx_data_dec_ref( tsx->last_tx );
-	    tsx->last_tx = NULL;
-	}
-	/* Cancel timeout timer. */
-	if (tsx->timeout_timer._timer_id != -1) {
-	    pjsip_endpt_cancel_timer(tsx->endpt, &tsx->timeout_timer);
-	    tsx->timeout_timer._timer_id = -1;
-	}
-	/* Cancel retransmission timer. */
-	if (tsx->retransmit_timer._timer_id != -1) {
-	    pjsip_endpt_cancel_timer(tsx->endpt, &tsx->retransmit_timer);
-	    tsx->retransmit_timer._timer_id = -1;
-	}
-
 	/* Reschedule timeout timer to destroy this transaction. */
 	if (tsx->transport_flag & TSX_HAS_PENDING_TRANSPORT) {
 	    tsx->transport_flag |= TSX_HAS_PENDING_DESTROY;
 	} else {
+	    /* Cancel timeout timer. */
+	    if (tsx->timeout_timer._timer_id != -1) {
+		pjsip_endpt_cancel_timer(tsx->endpt, &tsx->timeout_timer);
+		tsx->timeout_timer._timer_id = -1;
+	    }
+
 	    pjsip_endpt_schedule_timer( tsx->endpt, &tsx->timeout_timer, 
 					&timeout);
@@ -891,13 +937,4 @@
 
     } else if (state == PJSIP_TSX_STATE_DESTROYED) {
-
-	/* Clear TLS, so that mutex will not be unlocked */
-	struct tsx_lock_data *lck = pj_thread_local_get(pjsip_tsx_lock_tls_id);
-	while (lck) {
-	    if (lck->tsx == tsx) {
-		lck->is_alive = 0;
-	    }
-	    lck = lck->prev;
-	}
 
 	/* Unregister transaction. */
@@ -921,4 +958,5 @@
     pjsip_cseq_hdr *cseq;
     pjsip_via_hdr *via;
+    pjsip_host_info dst_info;
     struct tsx_lock_data lck;
     pj_status_t status;
@@ -999,4 +1037,13 @@
     pjsip_tx_data_add_ref(tsx->last_tx);
 
+    /* Determine whether reliable transport should be used initially.
+     * This will be updated whenever transport has changed.
+     */
+    status = pjsip_get_request_addr(tdata, &dst_info);
+    if (status != PJ_SUCCESS) {
+	tsx_destroy(tsx);
+	return status;
+    }
+    tsx->is_reliable = (dst_info.flag & PJSIP_TRANSPORT_RELIABLE);
 
     /* Register transaction to hash table. */
@@ -1006,4 +1053,7 @@
     /* Unlock transaction and return. */
     unlock_tsx(tsx, &lck);
+
+    PJ_LOG(5,(tsx->obj_name, "Transaction created for %s",
+	      pjsip_tx_data_get_info(tdata)));
 
     *p_tsx = tsx;
@@ -1113,4 +1163,9 @@
     unlock_tsx(tsx, &lck);
 
+
+    PJ_LOG(5,(tsx->obj_name, "Transaction created for %s",
+	      pjsip_rx_data_get_info(rdata)));
+
+
     *p_tsx = tsx;
     return PJ_SUCCESS;
@@ -1127,4 +1182,7 @@
     PJ_ASSERT_RETURN(tsx != NULL, PJ_EINVAL);
     PJ_ASSERT_RETURN(code >= 200, PJ_EINVAL);
+
+    if (tsx->state == PJSIP_TSX_STATE_TERMINATED)
+	return PJ_SUCCESS;
 
     lock_tsx(tsx, &lck);
@@ -1152,6 +1210,7 @@
     PJ_ASSERT_RETURN(tdata != NULL, PJ_EINVALIDOP);
 
-    PJ_LOG(5,(tsx->obj_name, "Request to transmit msg on state %s (tdata=%p)",
-                             state_str[tsx->state], tdata));
+    PJ_LOG(5,(tsx->obj_name, "Sending %s in state %s",
+                             pjsip_tx_data_get_info(tdata),
+			     state_str[tsx->state]));
 
     PJSIP_EVENT_INIT_TX_MSG(event, tsx, tdata);
@@ -1162,4 +1221,9 @@
     unlock_tsx(tsx, &lck);
 
+    /* Will always decrement tdata reference counter
+     * (consistent with other send functions.
+     */
+    pjsip_tx_data_dec_ref(tdata);
+
     return status;
 }
@@ -1176,6 +1240,6 @@
     pj_status_t status;
 
-    PJ_LOG(5,(tsx->obj_name, "Incoming msg on state %s (rdata=%p)", 
-	      state_str[tsx->state], rdata));
+    PJ_LOG(5,(tsx->obj_name, "Incoming %s in state %s", 
+	      pjsip_rx_data_get_info(rdata), state_str[tsx->state]));
 
     /* Put the transaction in the rdata's mod_data. */
@@ -1206,4 +1270,5 @@
 
 	if (tsx->transport != send_state->cur_transport) {
+	    /* Update transport. */
 	    if (tsx->transport) {
 		pjsip_transport_dec_ref(tsx->transport);
@@ -1212,8 +1277,20 @@
 	    tsx->transport = send_state->cur_transport;
 	    pjsip_transport_add_ref(tsx->transport);
+
+	    /* Update remote address. */
+	    tsx->addr_len = send_state->addr.entry[send_state->cur_addr].addr_len;
+	    pj_memcpy(&tsx->addr, 
+		      &send_state->addr.entry[send_state->cur_addr].addr,
+		      tsx->addr_len);
+
+	    /* Update is_reliable flag. */
+	    tsx->is_reliable = PJSIP_TRANSPORT_IS_RELIABLE(tsx->transport);
 	}
 
 	/* Clear pending transport flag. */
 	tsx->transport_flag &= ~(TSX_HAS_PENDING_TRANSPORT);
+
+	/* Mark that we have resolved the addresses. */
+	tsx->transport_flag |= TSX_HAS_RESOLVED_SERVER;
 
 	/* Pending destroy? */
@@ -1234,5 +1311,9 @@
 	if (tsx->transport_flag & TSX_HAS_PENDING_RESCHED) {
 	    tsx->transport_flag &= ~(TSX_HAS_PENDING_RESCHED);
-	    tsx_resched_retransmission(tsx);
+
+	    /* Only update when transport turns out to be unreliable. */
+	    if (!tsx->is_reliable) {
+		tsx_resched_retransmission(tsx);
+	    }
 	}
 
@@ -1252,14 +1333,34 @@
 
 	if (!*cont) {
-	    PJ_LOG(4,(tsx->obj_name, "Failed to send message! status=%d",
-		      -sent));
+	    char errmsg[PJSIP_ERR_MSG_SIZE];
+
+	    PJ_LOG(4,(tsx->obj_name, 
+		      "Failed to send %s! err=%d (%s)",
+		      pjsip_tx_data_get_info(send_state->tdata), -sent,
+		      pjsip_strerror(-sent, errmsg, sizeof(errmsg)).ptr));
 
 	    /* Clear pending transport flag. */
 	    tsx->transport_flag &= ~(TSX_HAS_PENDING_TRANSPORT);
 
-	    /* Terminate transaction. */
+	    /* Mark that we have resolved the addresses. */
+	    tsx->transport_flag |= TSX_HAS_RESOLVED_SERVER;
+
+	    /* Terminate transaction, if it's not already terminated. */
 	    tsx->status_code = PJSIP_SC_TSX_TRANSPORT_ERROR;
-	    tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, 
-			   PJSIP_EVENT_TRANSPORT_ERROR, send_state->tdata );
+	    if (tsx->state != PJSIP_TSX_STATE_TERMINATED &&
+		tsx->state != PJSIP_TSX_STATE_DESTROYED)
+	    {
+		tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, 
+			       PJSIP_EVENT_TRANSPORT_ERROR, send_state->tdata);
+	    }
+
+	} else {
+	    char errmsg[PJSIP_ERR_MSG_SIZE];
+
+	    PJ_LOG(4,(tsx->obj_name, 
+		      "Temporary failure in sending %s, "
+		      "will try next server. Err=%d (%s)",
+		      pjsip_tx_data_get_info(send_state->tdata), -sent,
+		      pjsip_strerror(-sent, errmsg, sizeof(errmsg)).ptr));
 	}
     }
@@ -1276,7 +1377,9 @@
 	pjsip_transaction *tsx = token;
 	struct tsx_lock_data lck;
-
-	PJ_LOG(4,(tsx->obj_name, "Failed to send message! status=%d",
-		  -sent));
+	char errmsg[PJSIP_ERR_MSG_SIZE];
+
+	PJ_LOG(4,(tsx->obj_name, "Transport failed to send %s! Err=%d (%s)",
+		  pjsip_tx_data_get_info(tdata), -sent,
+		  pjsip_strerror(-sent, errmsg, sizeof(errmsg)).ptr));
 
 	lock_tsx(tsx, &lck);
@@ -1301,5 +1404,5 @@
                                  pjsip_tx_data *tdata)
 {
-    pj_status_t status = PJ_EBUG;
+    pj_status_t status = PJ_SUCCESS;
 
     PJ_ASSERT_RETURN(tsx && tdata, PJ_EINVAL);
@@ -1311,67 +1414,109 @@
     }
 
+    /* If we have the transport, send the message using that transport.
+     * Otherwise perform full transport resolution.
+     */
+    if (tsx->transport) {
+	status = pjsip_transport_send( tsx->transport, tdata, &tsx->addr,
+				       tsx->addr_len, tsx, 
+				       &transport_callback);
+	if (status == PJ_EPENDING)
+	    status = PJ_SUCCESS;
+
+	if (status != PJ_SUCCESS) {
+	    char errmsg[PJSIP_ERR_MSG_SIZE];
+
+	    PJ_LOG(4,(tsx->obj_name, 
+		      "Error sending %s: Err=%d (%s)",
+		      pjsip_tx_data_get_info(tdata), status, 
+		      pjsip_strerror(status, errmsg, sizeof(errmsg)).ptr));
+
+	    /* On error, release transport to force using full transport
+	     * resolution procedure.
+	     */
+	    if (tsx->transport) {
+		pjsip_transport_dec_ref(tsx->transport);
+		tsx->transport = NULL;
+	    }
+	    tsx->addr_len = 0;
+	    tsx->res_addr.transport = NULL;
+	    tsx->res_addr.addr_len = 0;
+	} else {
+	    return PJ_SUCCESS;
+	}
+    }
+
+    /* We are here because we don't have transport, or we failed to send
+     * the message using existing transport. If we haven't resolved the
+     * server before, then begin the long process of resolving the server
+     * and send the message with possibly new server.
+     */
+    pj_assert(status != PJ_SUCCESS || tsx->transport == NULL);
+
+    /* If we have resolved the server, we treat the error as permanent error.
+     * Terminate transaction with transport error failure.
+     */
+    if (tsx->transport_flag & TSX_HAS_RESOLVED_SERVER) {
+	
+	char errmsg[PJSIP_ERR_MSG_SIZE];
+
+	if (status == PJ_SUCCESS) {
+	    pj_assert(!"Unexpected status!");
+	    status = PJ_EUNKNOWN;
+	}
+
+	/* We have resolved the server!.
+	 * Treat this as permanent transport error.
+	 */
+	PJ_LOG(4,(tsx->obj_name, 
+		  "Transport error, terminating transaction. "
+		  "Err=%d (%s)",
+		  status, 
+		  pjsip_strerror(status, errmsg, sizeof(errmsg)).ptr));
+
+	tsx->status_code = PJSIP_SC_TSX_TRANSPORT_ERROR;
+	tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, 
+		       PJSIP_EVENT_TRANSPORT_ERROR, NULL );
+
+	return status;
+    }
+
+    /* Must add reference counter because the send request functions
+     * decrement the reference counter.
+     */
+    pjsip_tx_data_add_ref(tdata);
+
+    /* Begin resolving destination etc to send the message. */
     if (tdata->msg->type == PJSIP_REQUEST_MSG) {
-	/* If we have the transport, send the message using that transport.
-	 * Otherwise perform full transport resolution.
-	 */
-	if (tsx->transport) {
-	    status = pjsip_transport_send( tsx->transport, tdata, &tsx->addr,
-					   tsx->addr_len, tsx, 
-					   &transport_callback);
-	    if (status == PJ_EPENDING)
-		status = PJ_SUCCESS;
-
-	    if (status != PJ_SUCCESS) {
-		/* On error, release transport to force using full transport
-		 * resolution procedure.
-		 */
-		if (tsx->transport) {
-		    pjsip_transport_dec_ref(tsx->transport);
-		    tsx->transport = NULL;
-		}
-		tsx->addr_len = 0;
-	    }
-	}
+
+	tsx->transport_flag |= TSX_HAS_PENDING_TRANSPORT;
+	status = pjsip_endpt_send_request_stateless(tsx->endpt, tdata, tsx,
+						    &send_msg_callback);
+	if (status == PJ_EPENDING)
+	    status = PJ_SUCCESS;
+	if (status != PJ_SUCCESS)
+	    pjsip_tx_data_dec_ref(tdata);
 	
-	if (!tsx->transport) {
-	    tsx->transport_flag |= TSX_HAS_PENDING_TRANSPORT;
-	    status = pjsip_endpt_send_request_stateless(tsx->endpt, tdata, tsx,
-							&send_msg_callback);
-	    if (status == PJ_EPENDING)
-		status = PJ_SUCCESS;
-	}
+	/* Check if transaction is terminated. */
+	if (status==PJ_SUCCESS && tsx->state == PJSIP_TSX_STATE_TERMINATED)
+	    status = PJSIP_ETSXDESTROYED;
 
     } else {
-	/* If we have the transport, send the message using that transport.
-	 * Otherwise perform full transport resolution.
-	 */
-	if (tsx->transport) {
-	    status = pjsip_transport_send( tsx->transport, tdata, 
-					   &tsx->addr, tsx->addr_len,
-					   tsx, &transport_callback);
-	    if (status == PJ_EPENDING)
-		status = PJ_SUCCESS;
-
-	    if (status != PJ_SUCCESS) {
-		if (tsx->transport) {
-		    pjsip_transport_dec_ref(tsx->transport);
-		    tsx->transport = NULL;
-		}
-		tsx->addr_len = 0;
-		tsx->res_addr.transport = NULL;
-		tsx->res_addr.addr_len = 0;
-	    }
-
-	} 
-
-	if (!tsx->transport) {
-	    tsx->transport_flag |= TSX_HAS_PENDING_TRANSPORT;
-	    status = pjsip_endpt_send_response( tsx->endpt, &tsx->res_addr, 
-						tdata, tsx, 
-						&send_msg_callback);
-	    if (status == PJ_EPENDING)
-		status = PJ_SUCCESS;
-	}
-    }
+
+	tsx->transport_flag |= TSX_HAS_PENDING_TRANSPORT;
+	status = pjsip_endpt_send_response( tsx->endpt, &tsx->res_addr, 
+					    tdata, tsx, 
+					    &send_msg_callback);
+	if (status == PJ_EPENDING)
+	    status = PJ_SUCCESS;
+	if (status != PJ_SUCCESS)
+	    pjsip_tx_data_dec_ref(tdata);
+
+	/* Check if transaction is terminated. */
+	if (status==PJ_SUCCESS && tsx->state == PJSIP_TSX_STATE_TERMINATED)
+	    status = PJSIP_ETSXDESTROYED;
+
+    }
+
 
     return status;
@@ -1409,6 +1554,7 @@
     PJ_ASSERT_RETURN(tsx->last_tx!=NULL, PJ_EBUG);
 
-    PJ_LOG(4,(tsx->obj_name, "retransmiting (tdata=%p, count=%d, restart?=%d)", 
-	      tsx->last_tx, tsx->retransmit_count, resched));
+    PJ_LOG(5,(tsx->obj_name, "Retransmiting %s, count=%d, restart?=%d", 
+	      pjsip_tx_data_get_info(tsx->last_tx), 
+	      tsx->retransmit_count, resched));
 
     ++tsx->retransmit_count;
@@ -1452,5 +1598,9 @@
 	pjsip_tx_data *tdata;
 
-	/* Must be transmit event. */
+	/* Must be transmit event. 
+	 * You may got this assertion when using loop transport with delay 
+	 * set to zero. That would cause on_rx_response() callback to be 
+	 * called before tsx_send_msg() has completed.
+	 */
 	PJ_ASSERT_RETURN(event->type == PJSIP_EVENT_TX_MSG, PJ_EBUG);
 
@@ -1483,5 +1633,5 @@
 	 * transport is being used.
 	 */
-	if (!PJSIP_TRANSPORT_IS_RELIABLE(tsx->transport))  {
+	if (!tsx->is_reliable)  {
 	    tsx->retransmit_count = 0;
 	    if (tsx->transport_flag & TSX_HAS_PENDING_TRANSPORT) {
@@ -1528,7 +1678,9 @@
 
 	/* Cancel retransmission timer. */
-	if (PJSIP_TRANSPORT_IS_RELIABLE(tsx->transport)==0) {
+	if (tsx->retransmit_timer._timer_id != -1) {
 	    pjsip_endpt_cancel_timer(tsx->endpt, &tsx->retransmit_timer);
-	}
+	    tsx->retransmit_timer._timer_id = -1;
+	}
+	tsx->transport_flag &= ~(TSX_HAS_PENDING_RESCHED);
 
 	/* Set status code */
@@ -1554,6 +1706,10 @@
 
 	/* Cancel retransmission timer A. */
-	if (PJSIP_TRANSPORT_IS_RELIABLE(tsx->transport)==0)
+	if (tsx->retransmit_timer._timer_id != -1) {
 	    pjsip_endpt_cancel_timer(tsx->endpt, &tsx->retransmit_timer);
+	    tsx->retransmit_timer._timer_id = -1;
+	}
+	tsx->transport_flag &= ~(TSX_HAS_PENDING_RESCHED);
+
 
 	/* Cancel timer B (transaction timeout) */
@@ -1739,5 +1895,5 @@
 		 * reliable transport.
 		 */
-		if (!PJSIP_TRANSPORT_IS_RELIABLE(tsx->transport)) {
+		if (!tsx->is_reliable) {
 		    timeout = timeout_timer_val;
 		} else {
@@ -1770,5 +1926,5 @@
 	     * timer G will be scheduled (retransmission).
 	     */
-	    if (!PJSIP_TRANSPORT_IS_RELIABLE(tsx->transport)) {
+	    if (!tsx->is_reliable) {
 		pjsip_cseq_hdr *cseq = pjsip_msg_find_hdr( msg, PJSIP_H_CSEQ,
                                                            NULL);
@@ -1894,5 +2050,5 @@
 	    /* For unreliable transport, start timer D (for INVITE) or 
 	     * timer K for non-INVITE. */
-	    if (PJSIP_TRANSPORT_IS_RELIABLE(tsx->transport) == 0) {
+	    if (!tsx->is_reliable) {
 		if (tsx->method.id == PJSIP_INVITE_METHOD) {
 		    timeout = td_timer_val;
@@ -1940,5 +2096,5 @@
 
 	/* Start Timer D with TD/T4 timer if unreliable transport is used. */
-	if (!PJSIP_TRANSPORT_IS_RELIABLE(tsx->transport)) {
+	if (!tsx->is_reliable) {
 	    if (tsx->method.id == PJSIP_INVITE_METHOD) {
 		timeout = td_timer_val;
@@ -1993,5 +2149,9 @@
 
 	    /* Cease retransmission. */
-	    pjsip_endpt_cancel_timer( tsx->endpt, &tsx->retransmit_timer );
+	    if (tsx->retransmit_timer._timer_id != -1) {
+		pjsip_endpt_cancel_timer(tsx->endpt, &tsx->retransmit_timer);
+		tsx->retransmit_timer._timer_id = -1;
+	    }
+	    tsx->transport_flag &= ~(TSX_HAS_PENDING_RESCHED);
 
 	    /* Start timer I in T4 interval (transaction termination). */
